""" aufgabe_ls3_02a.py - CPU-Monitoring-System - Datenerfassung und Speicherung
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  27.12.2020, 20.06.2022
    """


import time
import datetime
import psutil
import dblib


MESSINTERVALL = 5  # Messintervall festlegen


def db_zugriffswerte():
    """Funktion, die die Zugriffsdaten für eine MySQL-Datenbank liefert"""
    return "localhost", "root", "", "aufgabe_ls3_02"


def daten_erfassen():
    """daten_erfassen - Erfassung und Speicherung der CPU-Auslastung"""

    # Verbindung zur Datenbank aufbauen
    print("Verbindung zur Datenbank aufbauen")
    print("")
    host, user, passwd, db = db_zugriffswerte()
    connection = dblib.db_verbindung_aufbauen(host, user, passwd, db)

    # Schleife zur CPU-Erfassung und Speicherung
    print("CPU-Erfassung und Speicherung")
    while True:
        wert = psutil.cpu_percent()  # CPU-Erfassung
        wert = round(wert, 2)
        aktuelles_datum = datetime.datetime.now()
        zeit_string = aktuelles_datum.strftime("(%d.%m.%Y  %H:%M:%S)")
        print(zeit_string, "CPU-Auslastung:", wert, "%")
        sql_anweisung = "INSERT INTO t1_cpudata ( t1_wert) VALUES ( " + str(wert) + ")"
        dblib.db_nicht_abfrage_anweisung(connection, sql_anweisung)
        time.sleep(MESSINTERVALL)
    print("")

    # Verbindung zur Datenbank abbauen
    print("Verbindung zur Datenbank abbauen")
    print("")
    dblib.db_verbindung_abbauen(connection)


# Erfassung starten
daten_erfassen()
