""" aufgabe_ls3_02b_hauptmodul.py - CPU-Monitoring-System - interaktiver Teil
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  29.12.2020, 20.06.2022
    """


import dblib


def cpu_monitoring_system():
    """Hauptfunktion des CPU-Monitoring-System"""

    # Verbindung zur Datenbank aufbauen
    print("Verbindung zur Datenbank aufbauen")
    print("")
    host, user, passwd, db = db_zugriffswerte()
    connection = dblib.db_verbindung_aufbauen(host, user, passwd, db)

    # Hauptschleife mit Auswahlmenü und Befehlsverteiler
    beenden = False
    while not beenden:
        befehl = auswahl_menue()
        if befehl == 1:  # Anzeigen - Alle Daten
            anzeigen_alle_daten(connection)
        elif befehl == 2:  # Anzeigen - Intervall
            anzeigen_intervall(connection)
        elif befehl == 3:  # Exportiern in CSV-Datei - Alle Daten
            exportieren_alle_daten(connection)
        elif befehl == 4:  # Exportiern in CSV-Datei - Intervall
            exportieren_intervall(connection)
        elif befehl == 5:  # Löschen - Alle Daten
            loeschen_alle_daten(connection)
        elif befehl == 6:  # Statistik - Alle Daten
            anzeigen_statistik(connection)
        elif befehl == 0:  # Beenden
            beenden = True
        else:
            print("Unbekannter Befehl " + str(befehl))
            print("")

    # Verbindung zur Datenbank abbauen
    print("Verbindung zur Datenbank abbauen")
    print("")
    dblib.db_verbindung_abbauen(connection)

    print("CPU-Monitoring-System beendet")
    print("")


def auswahl_menue():
    """Auswahlmenü und Benutzerauswahl"""
    print("CPU-Monitoring-System")  # Überschrift
    print("---------------------")
    print("(1) Anzeigen - Alle Daten")  # Auswahlmenü
    print("(2) Anzeigen - Intervall")
    print("(3) Exportiern in CSV-Datei - Alle Daten")
    print("(4) Exportiern in CSV-Datei - Intervall")
    print("(5) Löschen - Alle Daten")
    print("(6) Statistik - Alle Daten")
    print("(0) Beenden")
    befehl = int(input("Auswahl: "))  # Benutzerauswahl
    print("")
    return befehl


def db_zugriffswerte():
    """Funktion, die die Zugriffsdaten für eine MySQL-Datenbank liefert"""
    return "localhost", "root", "", "aufgabe_ls3_02"


def anzeigen_alle_daten(connection):
    """Funktion, die alle Daten in der Konsole anzeigt"""

    print("CPU-Auslastung")  # Überschrift ausgeben
    print("--------------")
    print("")
    print("Zeitpunkt : Wert")
    result = dblib.db_abfrage_anweisung(connection, "SELECT * FROM t1_cpudata")
    for zeile in result:  # Ergebnis zeilenweise durchlaufen und ausgeben
        print(str(zeile[1]) + " : " + str(zeile[2]))
    print("")


def anzeigen_intervall(connection):
    """Funktion, die Daten eines Intervalls in der Konsole anzeigt"""

    print("CPU-Auslastung")  # Überschrift ausgeben
    print("--------------")
    print("")
    print("Zeitpunkt : Wert")
    start_zeitpunkt = input('Startzeitpunkt "JJJJ-MM-TT HH:MM:SS": ')
    end_zeitpunkt = input('Endzeitpunkt "JJJJ-MM-TT HH:MM:SS":   ')
    print("")
    print("Zeitpunkt : Wert")
    sql_anweisung = (
        "SELECT * FROM t1_cpudata WHERE "
        + start_zeitpunkt
        + " <= T1_zeit AND T1_zeit <= "
        + end_zeitpunkt
        + ";"
    )  # Daten aus Datenbank holen
    result = dblib.db_abfrage_anweisung(connection, sql_anweisung)
    for zeile in result:  # Ergebnis zeilenweise durchlaufen und ausgeben
        print(str(zeile[1]) + " : " + str(zeile[2]))
    print("")


def exportieren_alle_daten(connection):
    """Funktion, die alle Daten in eine CSV-Datei exportiert"""

    name_ausgabe_datei = input("Name Ausgabedatei: ")  # Ausgabedatei öffnen
    with open(name_ausgabe_datei, "w", encoding="utf-8") as datei:
        print("")
        print("Alle Daten exportieren ...")
        print("Zeitpunkt;Wert")
        ergebnis = dblib.db_abfrage_anweisung(connection, "SELECT * FROM t1_cpudata")
        for zeile in ergebnis:  # Ergebnis zeilenweise durchlaufen und exportieren
            datei.write(str(zeile[1]) + ";" + str(zeile[2]) + "\n")
        print("Datei ", name_ausgabe_datei, " erstellt.")
        print(len(ergebnis), " Datensätze exportiert.")
        print("")


def exportieren_intervall(connection):
    """Funktion, die Daten eines Intervalls in eine CSV-Datei exportiert"""

    name_ausgabe_datei = input("Name Ausgabedatei: ")  # Ausgabedatei öffnen
    with open(name_ausgabe_datei, "w", encoding="utf-8") as datei:
        start_zeitpunkt = input('Startzeitpunkt "JJJJ-MM-TT HH:MM:SS": ')
        end_zeitpunkt = input('Endzeitpunkt "JJJJ-MM-TT HH:MM:SS":   ')
        print("")
        print("Alle Daten exportieren ...")
        print("Zeitpunkt;Wert")
        sql_anweisung = (
            "SELECT * FROM t1_cpudata WHERE "
            + start_zeitpunkt
            + " <= T1_zeit AND T1_zeit <= "
            + end_zeitpunkt
            + ";"
        )  # Daten aus Datenbank holen
        ergebnis = dblib.db_abfrage_anweisung(connection, sql_anweisung)
        for zeile in ergebnis:  # Ergebnis zeilenweise durchlaufen und exportieren
            datei.write(str(zeile[1]) + ";" + str(zeile[2]) + "\n")
        print("Datei ", name_ausgabe_datei, " erstellt.")
        print(len(ergebnis), " Datensätze exportiert.")
        print("")


def loeschen_alle_daten(connection):
    """Funktion, die alle Daten löscht"""

    dblib.db_nicht_abfrage_anweisung(connection, "DELETE FROM t1_cpudata")

    print("Alle Daten gelöscht")
    print("")


def anzeigen_statistik(connection):
    """Funktion, die einfache statistische Auswertungen anzeigt"""

    print("CPU-Auslastung Statistik")  # Überschrift ausgeben
    print("------------------------")
    print("")
    result = dblib.db_abfrage_anweisung(
        connection, "SELECT COUNT(t1_wert), AVG(t1_wert), STD(t1_wert) FROM t1_cpudata"
    )
    zeile = result[0]
    print("Anzahl:            ", str(zeile[0]))
    print("Mittelwert:        ", round(zeile[1], 2))
    print("Standardabweichung:", round(zeile[2], 2))
    print("")

    result = dblib.db_abfrage_anweisung(
        connection, "SELECT MAX(t1_wert), MIN(t1_wert) FROM t1_cpudata"
    )
    zeile = result[0]
    print("Maximum:           ", round(zeile[0], 2))
    print("Minimum:           ", round(zeile[1], 2))
    print("")


# Aufruf des CPU-Monitoring-System
cpu_monitoring_system()
